package io.useless.play.authentication

import play.api.mvc.Controller

import io.useless.auth.Role._

trait Authentication
  extends BaseAuthentication
  with ClientAuthDaoComponent
{

  self: Controller =>

  lazy val authDao = new ClientAuthDao

}

trait BaseAuthentication
  extends AsyncActionComponent
  with    CompositeAuthenticatorComponent
  with    HeaderAuthenticatorComponent
  with    CookieAuthenticatorComponent
  with    QueryParameterAuthenticatorComponent
  with    RoleAuthorizerComponent
{

  self: Controller with
        AuthDaoComponent =>

  val authenticator = new CompositeAuthenticator(Seq(
    new HeaderAuthenticator("Authorization"),
    new CookieAuthenticator("auth"),
    new QueryParameterAuthenticator("auth")
  ))

  val requiredRoles: Seq[Role] = Seq()

  lazy val authorizer = new RoleAuthorizer(requiredRoles)

}
