package io.useless.play.json

import play.api.libs.json._
import play.api.libs.functional.syntax._

import io.useless.auth.{ Account, Api, App, User }
import io.useless.play.json.UuidJson._
import RoleJson._

object AccountJson {

  implicit val accountReads = new Reads[Account] {
    def reads(account: JsValue): JsResult[Account] = {
      ApiJson.apiReads.reads(account).
      orElse { AppJson.appReads.reads(account) }.
      orElse { UserJson.userReads.reads(account) }
    }
  }

  implicit val accountWrites = new Writes[Account] {
    def writes(account: Account): JsValue = account match {
      case api: Api => ApiJson.apiWrites.writes(api)
      case app: App => AppJson.appWrites.writes(app)
      case user: User => UserJson.userWrites.writes(user)
    }
  }

}
